#include <iostream>
#include <vector>
using namespace std;
int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int64_t n, k;
	cin >> n >> k;
	vector <uint64_t> nums(n);
	for (int64_t i = 0; i < n; i++)
	{
		cin >> nums[i];
	}

	vector < vector < uint64_t>> dp(2, vector < uint64_t>(n,0));   // максимальный и при К-той точке после Н-ного элемента
	dp[0] = nums;
	{
		for (size_t i = 1; i < n; i++)
		{
			dp[0][i] = dp[0][i] | dp[0][i - 1];
		}
	}

	for (int64_t Tk = 0; Tk < k-1; Tk++)
	{
		for (int64_t Tn = k; Tn < n; Tn++)
		{
			uint64_t Tec = nums[Tn];
			for (int64_t Tnn = Tn - 1; Tnn >= 0; Tnn--)
			{
				dp[1][Tn] = max (dp[1][Tn], dp[0][Tnn] & Tec);
				Tec = Tec | nums[Tnn];
			}
		}
		dp[0] = move(dp[1]);
		dp[1] = vector < uint64_t>(n, 0);
	}

//	uint64_t ans = 0;
	//for (size_t i = 0; i < n; i++)
	//{
//		ans = max(ans, dp[k-1][i]);
	//}

	cout << dp[0][n-1];
	return 0;
}
